package com.engine.organization.entity.comp.bo;

import com.engine.organization.entity.comp.dto.CompListDTO;
import com.engine.organization.entity.comp.param.CompSearchParam;
import com.engine.organization.entity.comp.po.CompPO;
import org.apache.commons.collections.CollectionUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @description: TODO
 * @author:dxfeng
 * @createTime: 2022/05/16
 * @version: 1.0
 */
public class CompBO {
    public static List<CompListDTO> buildCompDTOList(Collection<CompPO> list) {
        if (CollectionUtils.isEmpty(list)) {
            return Collections.emptyList();
        }
        List<CompListDTO> dtoList = list.stream().map(e -> CompListDTO.builder()
                .id(e.getId())
                .compNo(e.getCompNo())
                .compName(e.getCompName())
                .compNameShort(e.getCompNameShort())
                .parentCompany(e.getParentCompany())
                .orgCode(e.getOrgCode())
                .industry(e.getIndustry())
                .compPrincipal(e.getCompPrincipal())
                .forbiddenTag(e.getForbiddenTag())
                .build()
        ).collect(Collectors.toList());
        Map<Long, List<CompListDTO>> collects = dtoList.stream().filter(item -> null != item.getParentCompany() && 0 != item.getParentCompany()).collect(Collectors.groupingBy(CompListDTO::getParentCompany));
        return dtoList.stream().map(e -> {
            e.setChildren(collects.get(e.getId()));
            return e;
        }).filter(item -> null == item.getParentCompany() || 0 == item.getParentCompany()).collect(Collectors.toList());
    }

    public static CompPO convertParamToPO(CompSearchParam param, Long employeeId) {
        if (null == param) {
            return null;
        }
        return CompPO.builder()
                .id(param.getId() == null ? 0 : param.getId())
                .compNo(param.getCompNo())
                .compName(param.getCompName())
                .compNameShort(param.getCompNameShort())
                .parentCompany(param.getParentCompany())
                .orgCode(param.getOrgCode())
                .industry(param.getIndustry())
                .compPrincipal(param.getCompPrincipal())
                .description(param.getDescription())
                .forbiddenTag(param.getForbiddenTag() == null ? null : param.getForbiddenTag() ? 0 : 1)
                .deleteType(0)
                .createTime(new Date())
                .updateTime(new Date())
                .creator(employeeId)
                .build();

    }


}
